#!/usr/bin/env python
#-*-coding:utf-8-*-

from distutils.core import setup
import datetime as dt

aujour = dt.date.today()
sdate = ".".join([str(aujour)[2:4], str(aujour)[5:7], str(aujour)[8:10]])

setup(name = "pythoneon",
      version = sdate,
      description = "a Python library for producing electronic music",
      author = "René Bastian",
      author_email = "rbastian@free.fr",
      url = "http://www.musiques-rb.org",
      long_description = """a Python library for producing sounds and 
      organizing sounds in time and space; the audio formats are
      'raw' and/or 'wav'.
      """,
      license = "new or revised BSD license",    
      platforms = "GNU-Linux, may be other platforms",
      classifiers = [
        'Intended Audience :: Education',
        'Intended Audience :: End Users/Desktop',
        'Intended Audience :: Other Audience',
        'Programming Language :: Python',
        'Operating System :: POSIX :: Linux',
        'Natural Language :: French',
        'Topic :: Multimedia :: Sound/Audio :: Sound Synthesis',
        'Topic :: Artistic Software'
        ],
      packages = ['.']
      )
