#-*-coding:utf-8-*-

"""faire des copies numérotées d'un python ou d'un fichier
s'il a été modifié ou réécrit.
Pour que cela se fasse, insérer la ligne

[print] fairecopienumero(__file__)

à la fin du python à surveiller ;
'print' n'est pas nécessaire.
Commentaire :
   classe donc initialisation possible des
   'exclus', de la 'base', etc.
   
Le copiage ou le mouvage dans une base
est plus confortable à la main.

Recourir à os.stat ne me simplifie pas la vie :
    if os.stat(nom).st_ctime == os.stat(A[-1]).st_ctime :
        print os.stat(nom).st_ctime, os.stat(A[-1]).st_ctime
        print "Aucun changement"
        return.
16.07.08: j'essaie d'appliquer la fonction à des fichiers audio.
"""

import os

__author__ = "Copyright (c) 2005 René Bastian (Wissembourg, FRANCE)"
__date__ = "2005.12.30, 2006.01.19, 2008.07.16, 2008.12.28"

__all__ = ["fairecopienumero", "fairecopieaudionumero"]

debogue = False
muetglobal = True

def normer(ns, nn):
    """
    'ns': un string
    'nn': longueur que doit avoir 'ns'
    """
    while len(ns) < nn : 
        ns = "0" + ns
    return ns
    
def fairecopienumero(nom, repertoire = ".", nn = 3,
                     muet = muetglobal):
    """effectue une copie numérotée d'un fichier à la fin d'une exécution
    chaque fois qu'un changement du fichier est constaté par comparaison
    entre le fichier actuel et la dernière version numérotée.
    'nom' : nom du fichier scruté
    'exclus' : dernier caractères d'un nom de fichier dont on ne veut 
    tenir compte
    'nn' : nombre de positions du compteur (nn==3 -> 000 .. 999)
    'repertoire' : sous-répertoire scruté.
    CHANTIER: 
    """
    exclus = ["~", "c", "o"]
    n = len(nom)
    if not os.path.isdir(repertoire):
        os.mkdir(repertoire)
    
    X = os.listdir(".")
    A = [x for x in X if (x[:n] == nom) and not x[-1] in exclus]
    A.sort()
    R = os.listdir(repertoire)
    B = [x for x in R if (x[:n] == nom) and not x[-1] in exclus]
    B.sort()
    
    
    
    if (len(A) > 0) and (A[-1] == nom) : 
        nversion = 1
        ns = str(nversion)
        ns = normer(ns, nn)
        nomdestin = nom + "." + ns
        comm = " ".join(["cp", nom, nomdestin])
        os.system(comm)
        return nomdestin
    ACT = file(nom, "r").read()
    
    try :
        DER = file(A[-1], "r").read()
    except IndexError :
        if debogue : 
            print "fairecopienumero:", A
        DER = ACT
    if ACT == DER :
        if not muet :
            print "Pas de changement"
        return None 
    else :
        der = A[-1].split(".")[-1]
        while der[0] == "0": 
            der = der[1:]
        nversion = int(der)
        nversion += 1
        ns = str(nversion)
        ns = normer(ns, nn)
        nomdestin = nom+"."+ns
    comm = " ".join(["cp", nom, nomdestin])
    os.system(comm)
    return nomdestin

def fairecopieaudionumero(nom, repertoire = ".", nn = 3):
    """effectue une copie numérotée d'un fichier audio  au début d'une 
    exécution chaque fois qu'un changement du fichier est  constaté par 
    comparaison entre le fichier actuel et la dernière version numérotée.
    'nom' : nom du fichier audio    
    'nn' : nombre de positions du compteur (nn==3 -> 000 .. 999)
    'repertoire' : répertoire scruté."""
    n = len(nom)    
    os.chdir(repertoire)
    X = os.listdir(".")
    A = []
    for x in X :
        if (x[:n] == nom):
            A.append(x)
    A.sort()
    
    if (len(A) > 0) and (A[-1] == nom) : 
        nversion = 1
        ns = str(nversion)
        ns = normer(ns, nn)
        
         
        nomdestin = nom+"."+ns
        comm = " ".join(["cp", nom, nomdestin])
        os.system(comm)
        return nomdestin
    
    else :
        der = A[-1].split(".")[-1]
        while der[0] == "0": 
            der = der[1:]
        nversion = int(der)
        nversion += 1
        ns = str(nversion)
        ns = normer(ns, nn)
        
        
        nomdestin = ns + "." + nom
    comm = " ".join(["cp", nom, nomdestin])
    os.system(comm)
    return nomdestin

def usage():
    """'versionneur.py' fait des copies numérotées d'un python 
    ou d'un fichier s'il a été modifié ou réécrit.
    Pour que cela se fasse, insérer la ligne

    [print] fairecopienumero(__file__, <repertoire de stockage>)

    à la fin du python à surveiller ;
    'print' n'est pas nécessaire."""
    print usage.__doc__

if __name__ == "__main__":
    import sys
    try:
        option = sys.argv[1]
    except IndexError:
        option = None
    if option != None:
        usage()
    print fairecopienumero(__file__, repertoire='stocks')
    
    


